package com.northgrum.jacob.services.demo;
/**
 * Copyright 2010 Northrop Grumman Corporation
 * All Rights Reserved
 *
 * This material may be reproduced by or for the U.S. Government pursuant to the
 * copyright license under the clause at Defense Federal Acquisition Regulation
 * Supplement (DFARS) 252.227-7014 (June 1995).
 */


import java.security.Principal;
import java.sql.SQLException;
import java.util.Collection;
import java.util.LinkedHashMap;
import java.util.Map;
import java.util.Map.Entry;

import javax.annotation.Resource;
import javax.jws.WebService;
import javax.xml.ws.WebServiceContext;
import javax.xml.ws.handler.MessageContext;

import org.apache.cxf.ws.security.wss4j.WSS4JInInterceptor;

import com.northgrum.jacob.common.demo.JacobDemoService;

/**
 * The Class JacobDemoServiceImpl.
 * 
 * @author karnede
 */
@WebService (endpointInterface = "com.northgrum.jacob.common.demo.JacobDemoService", serviceName = "JacobDemoService")
public class JacobDemoServiceImpl implements JacobDemoService
{

   /** The ws context for getting the user name. */
   @Resource
   private WebServiceContext wsContext;

   /** The interfaces. */
   private Map<Integer, Object> map = new LinkedHashMap<Integer, Object>();

   /*
    * (non-Javadoc)
    * @see com.northgrum.jacob.JacobDemoService#echo(java.lang.String)
    */
   @Override
   public final String echo(final String text)
   {
      MessageContext mc = wsContext.getMessageContext();
      Principal p = (Principal) mc.get(WSS4JInInterceptor.PRINCIPAL_RESULT);
      System.out.println("User named '" + p.getName() + "' called echo:" + text);
      return "Service says " + text;
   }

   /*
    * (non-Javadoc)
    * @see com.northgrum.jacob.demo.JacobDemoService#addObjectToDemoMap(java.lang.Object)
    */
   @Override
   public final String addObjectToDemoMap(final Object o)
   {
      System.out.println("addObjectToDemoMap called with " + o);
      map.put(map.size() + 1, o);
      return o + " received, " + map.size() + " object(s) stored";
   }

   /*
    * (non-Javadoc)
    * @see com.northgrum.jacob.demo.JacobDemoService#getDemoMap()
    */
   @Override
   public final Map<Integer, Object> getDemoMap()
   {
      System.out.println("getDemoMap called");
      return map;
   }
}
